// ExampleControlCtrl.cpp : Implementation of the CExampleControlCtrl ActiveX Control class.

#include "stdafx.h"
#include "ExampleControl.h"
#include "ExampleControlCtrl.h"
#include "ExampleControlPropPage.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNCREATE(CExampleControlCtrl, COleControl)



// Message map

BEGIN_MESSAGE_MAP(CExampleControlCtrl, COleControl)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()



// Dispatch map

BEGIN_DISPATCH_MAP(CExampleControlCtrl, COleControl)
	DISP_FUNCTION_ID(CExampleControlCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()



// Event map

BEGIN_EVENT_MAP(CExampleControlCtrl, COleControl)
END_EVENT_MAP()



// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CExampleControlCtrl, 1)
	PROPPAGEID(CExampleControlPropPage::guid)
END_PROPPAGEIDS(CExampleControlCtrl)



// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CExampleControlCtrl, "ExampleControl.ExampleControl.1",
	0x39ada59, 0xc0de, 0x42dd, 0x9a, 0x1a, 0, 0x44, 0x90, 0xa1, 0x4f, 0xdc)



// Type library ID and version

IMPLEMENT_OLETYPELIB(CExampleControlCtrl, _tlid, _wVerMajor, _wVerMinor)



// Interface IDs

const IID BASED_CODE IID_DExampleControl =
		{ 0x6E686C2C, 0xD8A4, 0x4CE9, { 0x83, 0x49, 0x2E, 0x77, 0x39, 0xF3, 0x5F, 0x29 } };
const IID BASED_CODE IID_DExampleControlEvents =
		{ 0x24B8B937, 0xAEFA, 0x4286, { 0xB4, 0x3A, 0xBF, 0x50, 0xEF, 0x23, 0xC0, 0x33 } };



// Control type information

static const DWORD BASED_CODE _dwExampleControlOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CExampleControlCtrl, IDS_EXAMPLECONTROL, _dwExampleControlOleMisc)



// CExampleControlCtrl::CExampleControlCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CExampleControlCtrl

BOOL CExampleControlCtrl::CExampleControlCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_EXAMPLECONTROL,
			IDB_EXAMPLECONTROL,
			afxRegApartmentThreading,
			_dwExampleControlOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}



// CExampleControlCtrl::CExampleControlCtrl - Constructor

CExampleControlCtrl::CExampleControlCtrl()
{
	InitializeIIDs(&IID_DExampleControl, &IID_DExampleControlEvents);
	// TODO: Initialize your control's instance data here.
}



// CExampleControlCtrl::~CExampleControlCtrl - Destructor

CExampleControlCtrl::~CExampleControlCtrl()
{
	// TODO: Cleanup your control's instance data here.
}

void CExampleControlCtrl::OnClick(USHORT iButton)
{
	CString msg;
	int x,y;
	GetControlSize(&x,&y);
	msg.Format(L"Width: %d, Height, %d", x, y);
	MessageBox(msg, L"Example Control", MB_OK);
	COleControl::OnClick(iButton);
}

// CExampleControlCtrl::OnDraw - Drawing function

void CExampleControlCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	if (!pdc)
		return;
	// TODO: Replace the following code with your own drawing code.
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	pdc->Ellipse(rcBounds);
	CString msg;
	int x,y;
	GetControlSize(&x,&y);
	if(x!=m_width && y!=m_height)
	{
		m_width=x;
		m_height=y;
		msg.Format(L"Width: %d, Height, %d", x, y);
		MessageBox(msg, L"Example Control", MB_OK);
	}
}



// CExampleControlCtrl::DoPropExchange - Persistence support

void CExampleControlCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.
}



// CExampleControlCtrl::OnResetState - Reset control to default state

void CExampleControlCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}



// CExampleControlCtrl::AboutBox - Display an "About" box to the user

void CExampleControlCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_EXAMPLECONTROL);
	dlgAbout.DoModal();
}



// CExampleControlCtrl message handlers
